Bug 540248 - deadlock during signal handling
Summary: deadlock during signal handling
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: xorg-x11-server
Version: 11
Hardware: All
OS: Linux
low
medium
Target Milestone: ---
Assignee: X/OpenGL Maintenance List
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 573452
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-11-22 21:56 UTC by Dan Williams
Modified: 2010-03-17 03:51 UTC (History)
4 users (show)

Fixed In Version: xorg-x11-drv-synaptics-1.1.3-2.fc11
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-02-27 03:36:40 UTC


Attachments (Terms of Use)

Description Dan Williams 2009-11-22 21:56:16 UTC
Yeah, it's really xorg-x11-drv-intel screwing up here and failing malloc() in the first place, but shouldn't X somehow disable event processing not let drivers re-enter like synaptics is doing here with ReadInput?

Thread 1 (Thread 0x7fa3feb2f7b0 (LWP 1201)):
#0  __lll_lock_wait_private () at ../nptl/sysdeps/unix/sysv/linux/x86_64/lowlevellock.S:97
#1  0x00000030e8a7cc43 in _L_lock_9907 () at hooks.c:126
#2  0x00000030e8a7a8d7 in *__GI___libc_malloc (bytes=32) at malloc.c:3635
#3  0x00000000004e5dcb in TimerSet ()
#4  0x00007fa3fc4f0830 in ReadInput (local=0x54bfe70) at synaptics.c:1006
#5  0x000000000047d8d4 in ?? ()
#6  0x000000000046efa4 in ?? ()
#7  <signal handler called>
#8  0x00000000004eba90 in ?? ()
#9  <signal handler called>
#10 _int_malloc (av=0x30e8d69e80, bytes=65472) at malloc.c:4613
#11 0x00000030e8a7a8e2 in *__GI___libc_malloc (bytes=65472) at malloc.c:3638
#12 0x00007fa3fd9c9929 in drm_intel_setup_reloc_list (bo=<value optimized out>) at intel_bufmgr_gem.c:326
#13 drm_intel_gem_bo_emit_reloc (bo=<value optimized out>) at intel_bufmgr_gem.c:952
#14 0x00007fa3fdc3cab6 in i965_set_picture_surface_state (ss_bo=0x5b2ad80, ss_index=<value optimized out>, 
    pPicture=0x5b86420, pPixmap=0x604cda0, is_dst=<value optimized out>) at i965_render.c:980
#15 0x00007fa3fdc3cf0a in i965_prepare_composite (op=<value optimized out>, pSrcPicture=0x5d9ec20, 
    pMaskPicture=0x5c81160, pDstPicture=<value optimized out>, pSrc=<value optimized out>, pMask=0x5b5b5c0, 
    pDst=0x604cda0) at i965_render.c:1296
#16 0x00007fa3fdc4e05f in uxa_try_driver_composite (op=80 'P', pSrc=0x5d9ec20, pMask=0x5c81160, pDst=0x5b86420, 
    xSrc=<value optimized out>, ySrc=<value optimized out>, xMask=<value optimized out>, 
    yMask=<value optimized out>, xDst=6, yDst=120, width=<value optimized out>, height=<value optimized out>)
    at uxa-render.c:489
#17 0x00007fa3fdc4efd0 in uxa_composite (op=<value optimized out>, pSrc=0x5d9ec20, pMask=0x5c81160, 
    pDst=0x5b86420, xSrc=-64, ySrc=<value optimized out>, xMask=0, yMask=0, xDst=6, yDst=120, width=75, height=10)
    at uxa-render.c:747
#18 0x00007fa3fdc4f0a5 in uxa_try_magic_two_pass_composite_helper (height=<value optimized out>, 
    width=<value optimized out>, yDst=<value optimized out>, xDst=<value optimized out>, 
    yMask=<value optimized out>, xMask=<value optimized out>, ySrc=<value optimized out>, 
    xSrc=<value optimized out>, pDst=<value optimized out>, pMask=<value optimized out>, 
    pSrc=<value optimized out>, op=<value optimized out>) at uxa-render.c:603
#19 uxa_composite (height=<value optimized out>, width=<value optimized out>, yDst=<value optimized out>, 
    xDst=<value optimized out>, yMask=<value optimized out>, xMask=<value optimized out>, 
    ySrc=<value optimized out>, xSrc=<value optimized out>, pDst=<value optimized out>, 
    pMask=<value optimized out>, pSrc=<value optimized out>, op=<value optimized out>) at uxa-render.c:765
#20 0x000000000052eb90 in ?? ()
#21 0x00007fa3fdc4cec5 in uxa_glyphs (op=80 'P', pSrc=<value optimized out>, pDst=<value optimized out>, 
    maskFormat=<value optimized out>, xSrc=<value optimized out>, ySrc=<value optimized out>, nlist=1, 
    list=0x7fff9140d630, glyphs=0x7fff9140ce78) at uxa-glyphs.c:863
#22 0x000000000052eea4 in ?? ()
#23 0x00000000005281f2 in ?? ()
#24 0x00000000004471d4 in Dispatch ()
#25 0x000000000042d205 in main ()
Current language:  auto; currently asm
(gdb)

Comment 1 Dan Williams 2009-11-22 21:57:19 UTC
xorg-x11-server-Xorg-1.6.4-0.1.fc11.x86_64
xorg-x11-drv-intel-2.7.0-7.fc11.x86_64
libdrm-2.4.11-2.fc11.x86_64
xorg-x11-drv-synaptics-1.1.3-1.fc11.x86_64
kernel-2.6.30.9-96.fc11.x86_64

Comment 2 Fedora Update System 2009-12-09 17:41:36 UTC
xorg-x11-drv-synaptics-1.1.3-2.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/xorg-x11-drv-synaptics-1.1.3-2.fc11

Comment 3 Fedora Update System 2009-12-11 18:17:37 UTC
xorg-x11-drv-synaptics-1.1.3-2.fc11 has been pushed to the Fedora 11 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update xorg-x11-drv-synaptics'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F11/FEDORA-2009-13063

Comment 4 Sammy 2010-01-07 14:03:31 UTC
This patch leads to a crash (every time) during logout and shutdown and vt
switch on Thinkpad T61, F11 with latest updates and updates-testing, using
kdm as primary login manager and nvidia drivers from rpmfusion.

The keyboard is dsyfunctional and only way to get out is to hold down the
power button until power is turned off.

Going back to "-1" version fixes the problem.

Comment 5 Peter Hutterer 2010-01-08 05:05:35 UTC
Sammy, please attach your logfile from the crash.

Comment 6 Sammy 2010-01-08 15:37:12 UTC
I can't/don't get a logfile. The keyboard locks up only yhing I can do
is to force powerdown.

Comment 7 Fedora Update System 2010-02-27 03:36:35 UTC
xorg-x11-drv-synaptics-1.1.3-2.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.